{% block extrastyle %}
{% load i18n static %}{% get_current_language_bidi as LANGUAGE_BIDI %}
<style type="text/css">
  #{{ id }}_map { width: {{ map_width }}px; height: {{ map_height }}px; }
  #{{ id }}_map .aligned label { float:inherit; }
  #{{ id }}_admin_map { position: relative; vertical-align: top; float: {{ LANGUAGE_BIDI|yesno:"right,left" }}; }
  {% if not display_wkt %}#{{ id }} { display: none; }{% endif %}
  .olControlEditingToolbar .olControlModifyFeatureItemActive {
     background-image: url("{% static "admin/img/gis/move_vertex_on.svg" %}");
     background-repeat: no-repeat;
  }
  .olControlEditingToolbar .olControlModifyFeatureItemInactive {
     background-image: url("{% static "admin/img/gis/move_vertex_off.svg" %}");
     background-repeat: no-repeat;
  }
</style>
<!--[if IE]>
<style type="text/css">
  /* This fixes the mouse offset issues in IE. */
  #{{ id }}_admin_map { position: static; vertical-align: top; }
  /* `font-size: 0` fixes the 1px border between tiles, but borks LayerSwitcher.
      Thus, this is disabled until a better fix is found.
  #{{ id }}_map { width: {{ map_width }}px; height: {{ map_height }}px; font-size: 0; } */
</style>
<![endif]-->
{% endblock %}
<span id="{{ id }}_admin_map">
<script type="text/javascript">
//<![CDATA[
{% block openlayers %}{% include "gis/admin/openlayers.js" %}{% endblock %}
//]]>
</script>
<div id="{{ id }}_map"{% if LANGUAGE_BIDI %} dir="ltr"{% endif %}></div>
{% if editable %}
<a href="javascript:{{ module }}.clearFeatures()">{% trans "Delete all Features" %}</a>
{% endif %}
{% if display_wkt %}<p>{% trans "WKT debugging window:" %} </p>{% endif %}
<textarea id="{{ id }}" class="vWKTField required" cols="150" rows="10" name="{{ name }}">{{ wkt }}</textarea>

<input type="file" id="kml_file" name="kml_file">



<script src='https://npmcdn.com/@turf/turf/turf.min.js'></script>
{#<script type="text/javascript">#}
{#    var $ = django.jQuery;#}
{#</script>#}
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6-rc.1/css/select2.css" rel="stylesheet" />
{#<link href="https://cdnjs.cloudflare.com/ajax/libs/select2/3.5.4/select2.min.css" rel="stylesheet" />#}
<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6-rc.1/js/select2.min.js"></script>
{#<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/3.5.4/select2.min.js"></script>#}

<script type="text/javascript">
    
  {% block init_function %}{{ module }}.init();{% endblock %}

  function convertKmlToFeatures(kml) {
      var kmlFormat = new OpenLayers.Format.KML();
      var features = kmlFormat.read(kml);
      for (var i = 0, l = features.length; i < l; i++) {
          features[i].geometry.transform('EPSG:4326', 'EPSG:3857');
      }
      return features;
  }

  function zoomToPolygon(features) {
      if (features == null || features == '') {
          return;
      }

      var bounds = new OpenLayers.Bounds();
      for (var x in features) {
          bounds.extend(features[x].geometry.getBounds());
      }

      {{ module }}.map.zoomToExtent(bounds, false);
  }

  function process(kml) {

      if (kml == null || kml == '') {
          return '';
      }
      // Clear
      {{ module }}.clearFeatures()
      {{ module }}.deleteFeatures()

      // Convert kml to features.
      var features = convertKmlToFeatures(kml);
      {{ module }}.write_wkt(features[0])

      // Display features.
      {{ module }}.map.layers[1].addFeatures(features);

      // Zoom to the features.
      zoomToPolygon(features);
  }

  function handleFileSelect(evt) {
    var kml_file = evt.target.files[0]; // FileList object
    var reader = new FileReader();
    reader.onload = function(e) {
      var text = reader.result;
      process(text);
    };
    reader.readAsText(kml_file);
  }

  document.getElementById('kml_file').addEventListener('change', handleFileSelect, false);
  document.addEventListener('DOMContentLoaded', function() {
    var mapElement = document.getElementById('id_geometry_admin_map'); // Substitua pelo ID do seu elemento de mapa
    var body = document.querySelector('body');
    var originalOverflow = body.style.overflow;
    var timeout;

    if (mapElement) {
        mapElement.addEventListener('wheel', function(event) {
            // Verifica se o evento de rolagem é apenas para o mapa (não para a página)
            if (mapElement.contains(event.target)) {
                body.style.overflow = 'hidden'; // Desativa a rolagem do body

                // Limpa o timeout existente (se houver) para reiniciar o contador
                clearTimeout(timeout);

                // Define um novo timeout para restaurar o `overflow` após 500ms de inatividade
                timeout = setTimeout(function() {
                    body.style.overflow = originalOverflow; // Restaura o overflow do body
                }, 500);

                // Permite que o evento continue para o mapa (para zoom)
                if (event.deltaY !== 0) {
                    event.stopPropagation();
                }
            }
        }, { passive: false });
    }
});



  $(document).ready(function() {

      function formatState(state) {

        var $state = $(
              '<span ' + 'data-latitude="' + state.latitude + '" data-longitude="' + state.longitude + '">' + state.text + '</span>'
        );
        return $state;
      };

    $('.select-village-dropdown').select2({
        placeholder: '{% trans "Loading villages..." %}',
        templateResult: formatState,
        width: '250px',
        ajax: {
            url: '/api/simple_villages_with_position/',
            data: function (params) {
                var query = {
                    search: params.term,
                }
                return query;
            },
            processResults: function (data) {
                var items = data.map(function (o) { return {
                        "id": o.id,
                        "text": o.name,
                        "latitude": o.latitude,
                        "longitude": o.longitude
                    }
                });
                return {
                    results: items
                };
            }
        }
    });

    $('.select-village-dropdown').on('select2:select', function(e) {
        var data = e.params.data;
    
        var latitude = e.params.data.latitude;
        var longitude = e.params.data.longitude;
        var radius = 0.25;
        var options = { steps: 64, units: 'kilometers' };
        var format = new OpenLayers.Format.GeoJSON();

        var circle = turf.circle([longitude, latitude], radius, options);
        
        // Transformar as coordenadas de EPSG:4326 para EPSG:3857 usando OpenLayers
        var center = new OpenLayers.LonLat(longitude, latitude)
            .transform(new OpenLayers.Projection("EPSG:4326"), geodjango_geometry.map.getProjectionObject());

        // Converte o círculo para uma feature OpenLayers
        var feature = format.read(circle)[0];
        feature.geometry.transform(
            new OpenLayers.Projection("EPSG:4326"),  // Projeção de entrada (lon/lat)
            geodjango_geometry.map.getProjectionObject()  // Projeção do mapa
        );        
        // Adiciona o círculo ao mapa
        geodjango_geometry.map.layers[1].addFeatures([feature]);
        // Centraliza o mapa no círculo
        zoomToPolygon([feature]);
    });
});
</script>

<div id="select-village-dropdown-container">
    <p>{% trans "Create the polygon from a village:" %}</p>
    <select class="select-village-dropdown" name="aldeia">
    </select>
</div>

</span>




